from flask_jwt_extended import get_jwt_identity, jwt_required
from flask_socketio import emit, join_room

from infra.server import socketio
from repos.reservation_repo import ReservationRepository

@socketio.on('connect')
#@jwt_required()
def handle_connect():
    #current_user = get_jwt_identity()
    #print(f'Client connected: {current_user}')
    emit('status', {'message': 'Connected'})

@socketio.on('disconnect')
def handle_disconnect():
    print('Client disconnected')

@socketio.on('subscribe_reservations')
def handle_subscribe(data):
    room_id = data.get('room_id')
    date = data.get('date')
    room = f"{room_id}_{date}"
    join_room(room)
    reservations = ReservationRepository.list_all({
        'room_id': room_id,
        'date': date
    })
    emit('reservations_update', reservations)

def notify_clients(room_id, date):
    room = f"{room_id}_{date}"
    reservations = ReservationRepository.list_all({
        'room_id': room_id,
        'date': date
    })
    socketio.emit('reservations_update', reservations, room=room)